#Controles.pm
# Tiene rutinas de control para simusol1.pl
package Controles;
use warnings;
use strict;
use Data::Dumper;
use Termicos;
use GlobalesSimusol;
use Ayudas; 
our ($avisosgrav,$avisosnograv,$avisosnoseent)=(0,0,0);
our (@opciones,$opciones,$debug,$noverb);
our ($codconhandles,  $codelems, $codnodos); #definidas en Desdexml
BEGIN {
     use Exporter ();
     our ($VERSION,@ISA,@EXPORT,@EXPORT_OK,%EXPORT_TAGS);
     @ISA=qw(Exporter);
     @EXPORT=qw(&completar_guardarref_pedido
                &controlar_cadena_param 
                &controlar_circ
                &controlar_conex
                &controlar_def_funciones_propias
                &controlar_def_funciones_todas
                &controlar_def_funciones_final 
                &controlar_dpar_tiempos
                &controlar_elementos
                &controlar_iniciales_il_vc
                &controlar_iniciales_integr 
                &controlar_keys_iniciales
		&controlar_largos
                &controlar_layer
                &controlar_modelo 
                &controlar_pedidos_resultados
                &controlar_tiempos
                &controlar_uso_funciones
                &controlar_uso_def_argumentos 
                &controlar_uso_def_parametros 
                &controlar_uso_def_tablas
                &controlar_var
	       );
};
END();
# ---------------------------------------------------------------------------
sub controlar_keys_iniciales{
  comfin('com controlar_keys_iniciales', @_);
  my $refcirc = $_[0]; my $ref = $refcirc->{INICIALES};
  my @listainicialesori = @{$refcirc->{listaINICIALES}};
  #impr_debug(__LINE__.' Cont listaINICIALES', $refcirc->{listaINICIALES});
  my @lisini =();
  #impr_datos(__LINE__.' Cont keys_inic', ['TEMP','temp'], $refcirc);
  # se ignoran errores provenientes de haber modificado el diagrama
  # eliminando partes
  my @lisnoborrada;
  foreach my $key (@listainicialesori) {
      $key =~ /^;/ and do{push @lisini, $key; push @lisnoborrada, $key; next}; 
      my ($pal1,$numpar,$reflista) 
           = controlar_sintaxis_simple('INICIALES',$key); 
      if ($numpar > 1) {
           parar1(85,$refcirc,
             "Más de un par de paréntesis en $key para  (INICIALES)"); 
      }; 
      my ($cont1) = (@$reflista,'');
      my @octeto  = buscar_abreviaturas( #controlar_keys_iniciales
                   $refcirc, $pal1,$cont1,'INICIALES');
      #impr_debug(__LINE__.' Cont octeto para '. "$pal1 $cont1", \@octeto);
      my ($tipo, $plantilla, $eleparnodo, $cont0, $palequiv
                     ,$pala,$propio,$cont00) 
          = @octeto; 
      $tipo eq 'e' and do{
	  avnoseent("dar un valor inicial relacionado con algo inexistente
                     $key");
          borrar_datos($refcirc,'INICIALES',$key,''
               ,__LINE__.' Cont keys_ini');
          next;
      };
      $tipo eq 'p' and not defined $refcirc->{PARAMETROS}->{"D$key"} and do{
	  avnoseent("dar valor inicial a un parametro que no hay que integrar
                   $key");
          borrar_datos($refcirc,'INICIALES',$key,1
               ,__LINE__.' Cont keys_ini');
          next;
      };
      #impr_debug(__LINE__.' Cont octeto para '. "$pal1 $cont1", \@octeto);
      $cont00 eq '' or 
          parar1(86,$refcirc,"Error de sintaxis en $key (INICIALES)");
      if ($tipo eq 'a') {
           if ($eleparnodo =~ /^E/ and $palequiv eq 'V'    
                or $eleparnodo =~ /^J/ and $palequiv eq 'I') {
                        parar1(87, $refcirc
                 , "A las fuentes no se le pueden asignar valores iniciales;
                      dato incorrecto: $key");
           } else {
                  $eleparnodo = "$palequiv$eleparnodo";
           };
       } elsif  ($palequiv eq 'V' and $tipo eq 'n') {
	   my $listaC = $refcirc->{cualesEC}->{"$eleparnodo-0"}; my @listaC;
           my $listaC1 = $refcirc->{cualesEC}->{$eleparnodo};
           defined $listaC and @listaC = @$listaC;
           defined $listaC1 and push @listaC, @$listaC1;
           if (defined $listaC) {
	       my @listaC = grep (/^C/, @$listaC);
	    };
	    @listaC  or do {
	         avnoseent
                    ("asignar valor inicial para un nodo si no está asociado 
                    a un acumulador a tierra (INICIALES)");
                 borrar_datos($refcirc,'INICIALES',$key,''
                      ,__LINE__.' Cont keys_ini');
		 next; 	    };
            $eleparnodo = "V$listaC[0]";  
       } elsif ($tipo eq 't') {
             parar1(88,$refcirc
	    ,"No asigne valor inicial para el tiempo en el cuadro INICIALES");
       };
       if ($eleparnodo) { 
           if ($eleparnodo =~ /^VE/i or $eleparnodo =~ /^IJ/i) {
                        parar1(83, $refcirc
                 , "$key se refiere a $eleparnodo; y a las fuentes 
             no se le pueden asignar valores iniciales");
	   }; 
           push @lisini, $eleparnodo;
           push @lisnoborrada, $key; 
           mover_datos($refcirc,'INICIALES',$key
                       ,$refcirc,'INICIALES',$eleparnodo
                   , __LINE__.' Cont contr.inikey');
           if ($key ne $eleparnodo) {
                $refcirc->{INIoriginal}->{$eleparnodo} = $key;
           };
      } else {
            parar1(89,$refcirc,"$key no indica ningún valor inicial");
      };  
  }; #foreach
  my @listainiciales = union_conorden (@lisini);
  @listainicialesori = union_conorden (@listainicialesori);
  #my @depulisiniori = grep ($_ !~ /^;/, @listainicialesori);
  @listainiciales ==  @lisnoborrada or do{
     my $cualesori = join ' , ',  @lisnoborrada;
     my $cuales = join ' , ', @listainiciales;
     parar1(84, $refcirc
        ,"Hay más de un valor inicial para una misma variable del Sceptre
        datos para: $cualesori
        se refieren a   $cuales");
  };    
  #impr_debug(__LINE__.' Cont listaINICIALES', $refcirc->{listaINICIALES});
  #impr_debug(__LINE__.' Cont INICIALES', $refcirc->{INICIALES});
  $refcirc->{listaINICIALES} = \@lisini;
  #impr_debug(__LINE__.' Cont listaINICIALES', $refcirc->{listaINICIALES});

  comfin('fin controlar_keys_iniciales',@lisini
           , ['INICIALES'],$refcirc,'impr');
}  
#----------------------------------------------------------------------------
sub controlar_sintaxis_simple{
#se usa para pedido de resultados y keys de iniciales
# debe ser una palabra y uno o dos parentesis
#devuelve codigo de error (numera>0 0 '') y
#una cuaterna con '', la palabra, núm de parentesis, y referencia a  
#lista de contenidos de parentesis
  my ($quien,$pedido) = @_;
  my ($palabra,$numpar,$reflista);
  $pedido !~ /[\(\)]/  and return ($pedido,0,[]);
  my $pedidoori = $pedido;
  $pedido =~ s/\)\s*$// or do{
      parar1(70,0,"Debiera terminar con paréntesis: $pedidoori ($quien)"
                 , $CORTOA);
  };
  if ($pedido !~ s/^\s*(\w[^\(\)]*)//){
      parar1(71,0,"No empieza con variable: $pedido ($quien)", $CORTOA);
  };
  $palabra = $1;
  $palabra =~ /^\D/ or do{
      parar1(72,0,"Debiera comenzar con letra $pedidoori ($quien)",$CORTOA);
  };
  $palabra =~ s/\s*$//;
  $pedido =~ s/^\(\s*//  or do{
      parar1(73,0,"Paréntesis mal apareados en  $pedidoori ($quien)",$CORTOA);
      #juntar por paren controla esto?
  };
  my @lista = split /\)\s*\(/, $pedido;
  my @listamal = grep (/[\(\)]/, @lista);
  @listamal and do{
      parar1(74,0,"Paréntesis incorrectos en $pedidoori ($quien)".$CORTOA);
  };
  return ($palabra,scalar @lista,\@lista);
} #controlar sintaxis
#----------------------------------------------------------------------------
sub controlar_pedidos_resultados{
  comfin('com controlar_pedidos_resultados',@_);
  my ($ref, @listapedidos) = @_;
  $ref->{talcualmalos} = [];#lo cargar controlar_pedido()
  #detecta posibles ambigüedades y prepara pedido de resultados
  #impr_datos(__LINE__.' Cont c_ped._resultados', ['TEMP','temp'], $ref);
  foreach my $pedido (@listapedidos) {
      impr_debug(__LINE__.' Cont $pedido DOLO', $pedido);
      my ($tipo,$plantilla,$sceptre, $palequiv,$pala, $propio,$dentro ) 
           = controlar_pedido($ref,$pedido); 
      #si hizo falta, ya paró     
      $dentro ne '' or $dentro = $propio;
      my @listadentro = split /\s*\,\s*/, $dentro;
      my $cuantos = scalar @listadentro;
      if ($cuantos !~ /^[13]$/) { 
           @listadentro = ($listadentro[0]); 
          avnograv("Pedido de resultado incorrecto; lo interpretamos:
              $pedido   =>    $sceptre($listadentro[0])"); 
      };
      $dentro = join ',',@listadentro;
      #impr_debug(__LINE__.' Cont $sceptre $dentro $tipo $palequiv'
      #       , [$sceptre,$dentro,$tipo,$palequiv]);
      completar_guardarref_pedido($ref
            ,$tipo,$plantilla,$sceptre, $palequiv,$pala, $propio,$dentro,$pedido); 
  };
  if (@{$ref->{talcualmalos}}) { 
      avgrav("No se entienden los pedidos de resultados: @{$ref->{talcualmalos}}
        (buenos: @{$ref->{talcualbuenos}}; corresponden a: @{$ref->{listasceptre}})");
      my %malos; 
      foreach (@{$ref->{talcualmalos}}) {
          $malos{$_} = 1;
      };
      @{$ref->{listapeddos}} = (undef $malos{$_},@{$ref->{listapedidos}});
  };    
  comfin('fin controlar_pedidos_resultados',@{$ref->{listapedidos}}
      ,' sceptre: ' ,@{$ref->{listasceptre}},' tiparg: ',$ref->{tiparg});
  return ''; 
} #controlar_pedidos_resultados
#---------------------------------------------------------------------------
sub controlar_pedido{ 
  comfin('com controlar_pedido',@_ );
  my ($ref, $pedido) = @_; 
  #impr_debug(__LINE__.' Cont $pedido (oori)', $pedido);
  #se admite una palabra y uno o dos pares de parentesis 
  #devuelve un codigo de error o 
  my ($pal1,$numpar,$reflista)
      = controlar_sintaxis_simple('RESULTADOS', $pedido); 
  #ya paro si hubo errores de sintaxis
  #impr_debug(__LINE__.' Cont $cod_err,$pal1,$numpar'
  #          , [$pal1,$numpar]);
  if ($numpar >2) {
      parar1(75,$ref,"Más de dos pares de paréntesis en $pedido (RESULTADOS)");
  }; 
  my ($cont1,$cont2) = (@$reflista,'',''); #para que no queden indefinidos

  my @octeto = buscar_abreviaturas(   #controlar_pedido
                    $ref, $pal1,$cont1,'RESULTADOS'); 
  @octeto == 1 and do{#ambigÜedad
      explic("(en el pedido de RESULTADOS  $pedido)");
      parar1($octeto[0],$ref);
  };
  #impr_debug(__LINE__.' Cont @octeto' ,\@octeto);
  my ($tipo, $plantilla, $eleparnodo, $cont0, $palequiv,$pala,$propio,$cont00) 
          = @octeto; 
  $tipo eq 'e'  and do{
        push @{$ref->{talcualmalos}}, $pedido;
        return 'e',0,'??','??','??',$pedido,$pal1.',??,??';
  }; 
  my $dentro;
  if ($cont00 ne '' and $cont2 eq '') {
      $dentro = $cont00;
  } elsif ($cont00 eq '') {
      $dentro = $cont2;
  } elsif ($cont2 ne '') {
      avnoseent("$pedido (RESULTADOS)");
           return 'e',0,'??','','',$pedido,,$pal1.',??,??';
  };
  my $sceptre ;
  if ($tipo eq 'a') {
      if ($eleparnodo =~ /^E/ and $palequiv eq 'V' 
          or $eleparnodo =~ /^J/ and $palequiv eq 'I') {
          $sceptre = $eleparnodo; 
      } elsif ($palequiv eq 'V') { 
         my $ped1 = $ref->{TEMP}->{$eleparnodo};
         defined $ped1 and $sceptre = $ped1  or $sceptre = "V$eleparnodo";
     } elsif ($palequiv eq 'I') {
         $sceptre = "$palequiv$eleparnodo";
     } else {
         $sceptre = $eleparnodo;
     }; 
  } elsif  ($tipo eq 'n')  { #esta es 'n' de nodo 
      my $ped1 = $ref->{TEMP}->{$eleparnodo};
      if (defined $ped1) {
          $sceptre = $ped1;
      } else {
          $sceptre = cerofuentear($ref, $eleparnodo) 
      };             
  } elsif ($tipo eq 'p') {
      my $ntipo = $ref->{TIPPARAMETROS}->{$eleparnodo};
      $sceptre = $eleparnodo; 
      #impr_debug(__LINE__.' Cont $tipo,$ntipo,$plantilla,$eleparnodo '
      #		 ,[$tipo,$ntipo,$plantilla,$eleparnodo]);
      #seguro está definido, salvo que el parametro este dado por su derivada
      if (not defined $ntipo) {
      } elsif (lc($ntipo) =~ /[pa]/) {
          #impr_dat_que($eleparnodo,'PARAMETROS',
          #            __LINE__.' Cont se cambia para sceptre', $ref,'cp'); 
	  $sceptre  = $ref->{PARAMETROS}->{$eleparnodo};
      } elsif (lc($ntipo) eq 'n') {
	  #impr_debug(__LINE__.' Cont VIEJOPARAMETROS '
          #     ,Dumper $ref->{VIEJOPARAMETROS});
	  #impr_debug(__LINE__.' Cont TIPVIEJOPARAMETROS '
          #     ,Dumper $ref->{TIPVIEJOPARAMETROS});
	  my $viejo = $ref->{VIEJOPARAMETROS}->{$eleparnodo};
	  my $tipviejo = $ref->{TIPVIEJOPARAMETROS}->{$eleparnodo};
          defined $viejo and $tipviejo =~ /[pa]/ and $sceptre = $viejo;
      #} else {
      #    $sceptre = $eleparnodo;
      };
  } elsif ($tipo eq 't') {
      $sceptre = 'TIME';   
  };
  comfin('fin controlar_pedido','
       "",$tipo,$plantilla,$sceptre,$palequiv,$pala,$propio,$dentro
    ', '',$tipo,$plantilla,$sceptre,$palequiv,$pala,$propio,$dentro );
  #impr_debug(__LINE__.' Cont  cont_p_resultado retorno'
  #       ,[$tipo,$plantilla,$sceptre,$palequiv ,$pala,$propio,$dentro]);
  return $tipo,$plantilla,$sceptre,$palequiv ,$pala,$propio,$dentro;
} # controlar_pedido
#---------------------------------------------------------------------------
sub completar_guardarref_pedido{
  comfin('com completar_guardarref',@_) ;
  my ($ref, $tipo,$plantilla,$sceptre,$palequiv ,$pala,$propio,$dentro,$pedido)
     = @_;
  my %equi = ('V' => 'E', 'I' => 'J');
  my $comp;
  if ($dentro =~/^.*\,.*\,.*$/) { 
  } else {
      #impr_debug(__LINE__.' Cont $propio $nombreplantilla->[$plantilla]'
      #		 ,[$propio, $nombreplantilla->[$plantilla]]);
      if ($palequiv ne '') {
          $comp = $deficomp->{$plantilla}->{$equi{$palequiv}};
          if (not defined $comp) {
	     my $pl = substr($nombreplantilla->[$plantilla],0, 2);
             $comp = "$pala??,$pala??";
	 };
      } else {
          if ($tipo eq 'a') { # por ejemplo un resultado de Resist.
	      $sceptre =~ /^(.)/ ;  my $cod = $1;  
              $comp = $deficomp->{$plantilla}->{$cod};
              if (not defined $comp) {
                  my $pl = substr($nombreplantilla->[$plantilla],0, 2);
                  $comp ="$cod??,$cod??";
              };
          } elsif ($tipo eq 't') {
              $comp = 'tiempo,s';
          } else {
              $comp or $comp ='??,??';
          };
      };
      $dentro .=  ",$comp";
  };
  #impr_debug(__LINE__.' Cont  comp_guard $sceptre $dentro $tipo'
  #   , [$sceptre, $dentro, $tipo]);
  if ($tipo ne 'e') {  
     push @{$ref->{listapedidos}} ,"$sceptre($dentro)";
     push @{$ref->{listasceptre}}, $sceptre;
     push @{$ref->{talcualbuenos}}, $pedido;
  } else {
     push @{$ref->{listapedidos}}, "??($dentro)";  
  };
  $ref->{tiparg} .= $tipo;
  comfin('fin completar_guardarref');
} #completar_guardarref_pedido
#---------------------------------------------------------------------------
sub controlar_nodos{
    my $refc = $_[0];
    my @nodos = keys %{$refc->{cualobjtextonodo}};
    return unless @nodos;
    @nodos = grep ($_ ne '0',@nodos);
    #impr_debug(__LINE__.' Cont nodos no 0', \@nodos);
    return unless @nodos;
    #impr_obj(__LINE__.' Cont nodos', '[Nnt]');
    foreach my $nodo (@nodos) {
	my @lisobj = @{$refc->{cualobjtextonodo}->{$nodo}};
	my @dobles = grep($codlista->[$_] eq 'n',@lisobj);
        my @simples =  grep($codlista->[$_] eq 'N',@lisobj);
	my $lugaress = '';
        map($lugaress .= $lugarlista->[$_], @simples);
        my $lugaresd = '';
        map($lugaresd .= $lugarlista->[$_], @dobles);
        if (@simples == 0) {
            avnograv(
       "Debe haber un nodo simple con igual identificación que el(los) doble(s)
           $nodo; ver lugares $lugaresd");
        } elsif(@simples>1) { #este control se hace despues.
	};
    }; 
}#  
#---------------------------------------------------------------------------
sub controlar_conex{
  comfin('com controlar_conex',@_);
  my $reflay = $_[0]; my $refcirc = $reflay->{refcirc};
  #impr_ramas(__LINE__.' Cont contr. conex', $reflay);
  my ($lisramas, $lisramasuna, $lisramassueltas,
        $lisramasquerepiten, $lisramasauxiliares) =
     @$reflay{'lisramas','lisramasuna', 'lisramassueltas',
              'lisramasquerepiten', 'lisramasauxiliares'};
  if (@$lisramasquerepiten) {
      my $puntos ='';
      foreach my $rama (@$lisramasquerepiten) {
         foreach (@{$reflay->{conexiones}->{$rama}}) {
	     $puntos .= $_->{lugar};
         };
         $puntos .= "\n";
      };         
      parar1(66,$reflay->{refcirc}
       ,"Hay ramas repetidas entre los puntos de coordenadas:\n    $puntos");
  };
  if (@$lisramasuna + @$lisramassueltas) {
      do{
         explic(
	     "\nHay ramas no bien conectados (o conectados a algo inútil,
          en $refcirc->{archivo}, capa $reflay->{capa})");
          if (@$lisramasuna) { 
              my $mens10 = scalar @$lisramasuna; 
              my (@mens11, $mens11); 
              foreach my $rama (@$lisramasuna) { 
                 push (@mens11, $reflay->{lugpuntos}->{$rama}->[0] .
		       $reflay->{lugpuntos}->{$rama}->[-1]."
                        sólo bien conectado en " .
                        "$reflay->{conexiones}->{$rama}->[0]->{lugar}"), 
              };               
              $mens11 = join "\n  ",@mens11 ;  
	      parar1(66,$reflay->{refcirc}
               ,"$mens10  ramas con un solo enganche bueno:\n    $mens11");
	  };
          my $cuantas = scalar @$lisramassueltas; my $mens0 ;
           if ($cuantas) { 
              $mens0 = scalar @$lisramassueltas . 
		          ' con ningún enganche bueno;' . "\n";
              foreach my $rama (@$lisramassueltas) {
                  $mens0 .= 
                  "Puntos de la rama en   @{$reflay->{lugpuntos}->{$rama}}\n";
              };
              avnograv('Hay ramas inútiles: ' . $mens0);
          };      
      }; #do
  };
  comfin('fin controlar_conex');
} #controlar_conex
#---------------------------------------------------------------------------
sub controlar_uso_def_argumentos{# solo carga $ref->{USAFUN},etc
   comfin('com controlar_uso_def_argumentos', @_);
   my ($ref,$lisque) = @_;
   my $listarg = $ref->{listaarg}; my $sonarg;
   #impr_debug(__LINE__.' Cont argumentos',$listaarg);
   map($sonarg->{$_} = 1,@{$ref->{listaarg}});
   #impr_debug(__LINE__.' Cont sonarg',$sonarg);
   ($ref->{USAFUN}, $ref->{USAPAR} , $ref->{USATAB}, $ref->{USAVAR},
    $ref->{USAFUNX}) = Tablasfuncq::usados  #en controlar_uso_def_argumentos
        ($lisque,$ref,$sonarg);
   #impr_debug(__LINE__.' Cont USAFUN',$ref->{USAFUN});
   comfin('fin controlar_uso_def_argumentos');
}# controlar_uso_def_argumentos 
# --------------------------------------------------------------------------
sub controlar_modelo{ # sin sustituir nada;
  #se controla un modelo cuando es el principal o cuando es "bueno"
  # para el circuito 
 comfin('com controlar_modelo', @_);
  my $refcirc=$_[0];
  my %nodext;my %nod;my %aignorar;
  my @nodos = keys %{$refcirc->{cualobjtextonodo}};
  my @eles =  keys %{$refcirc->{cualobjele}};
  my $comodin = $refcirc->{comodin};
 #Nodos
 my (@nodostot,@nodosext,,@nodosint,@nodosext_nousados,@nodosint_rep);
  if (defined $refcirc->{uni}->{$comodin}) {
      @nodostot = split ('-',$refcirc->{uni}->{$comodin});
      @nodosext = grep( $_ !~ /^$comodin\s*$/,@nodostot);
      @nodosint = grep(do{$_ =~ /^$comodin\s*$/ and $_ ne '0'},@nodostot);
      #impr_debug(__LINE__.' Cont @nodosext ',  \@nodosext);  
      #impr_debug(__LINE__.' Cont %nod ',  \%nod);  
      @nodosext_nousados = grep(do{$nod{$_} != 2},@nodosext);
      @nodosint_rep = grep($nod{$_}>1,@nodosint);
  };
  map(do{$nod{$_} = scalar @{$refcirc->{cualobjtextonodo}->{$_}}},@nodos);
  foreach (@nodosint_rep) { 
     my @codigos; my @lista = @{$refcirc->{cualobjtextonodo}->{$_}};
     map($_ = $codlista->[$_],@lista);
     #impr_debug(__LINE__.' Cont ',\@lista);
     my @lisN = grep(/N/,@lista);
     @lisN and do{
	 porparar1(91,$refcirc, "$_ es un nodo repetido no anunciado");
         return 91;
     };     
  };
  if (@nodosext_nousados) {
      my $cuales = join ' ',@nodosext_nousados;
      porparar1(92,$refcirc
        ,"Hay nodos exteriores no usados en el modelo (o internos 
               que no terminan en $comodin): $cuales");
	       return 92;
  };
  $nodext{0} = 1;
  map($aignorar{"TEMP_$_"} = 1, @nodos);
  map($aignorar{$_} = 1, keys %{$refcirc->{ARGUS}});
  map($aignorar{$_} = 1, keys %{$refcirc->{PARAMETROS}});
  #impr_debug(__LINE__.' Cont argus',  $refcirc->{ARGUS});
  #impr_debug(__LINE__.' Cont parametros',  $refcirc->{PARAMETROS});
  #impr_debug(__LINE__.' Cont cualobjele',  Dumper $refcirc->{cualobjele});
  foreach (keys %{$refcirc->{cualobjele}}) {
      /$comodin$/  or do{
          porparar1(94,$refcirc
              ,"El nombre $_ no es bueno para un elemento en el modelo;  
                    debe terminar en $comodin");
          return 94  
      };
  };
  #print 'Cont '. __LINE__ .' @nodos',join(' ',@nodos),"\n"; 
  #imprhash('Cont ' . __LINE__ . ' %nodext ',%nodext); 

  #impr_debug(__LINE__.' Cont ', \@nodosext);
  #impr_debug(__LINE__.' Cont',Dumper $refcirc->{nodorepe});
  controlar_uso_def_argumentos(  #en controlar_modelo
        $refcirc,['DATOS','PARAMETROS','RESULTADOS']);
  #impr_debug(__LINE__.' Cont aignorar',  \%aignorar);
  controlar_var($refcirc, \%aignorar);#en controlar_modelo
  if ($avisosgrav) {
      porparar1(90, $refcirc);
      return 90;
  };
  comfin('fin controlar_modelo' ); 
  return '';
}#controlar_modelo
# --------------------------------------------------------------------------
sub controlar_circ{ # sin sustituir nada;
  comfin('com controlar_circ', @_);
  my ($refcirc,$codcirc) = @_;
  controlar_nodos($refcirc);
  if (defined $refcirc->{lisnodoscreados}) {
      my @cuales = (); my @cu = (); my $i = 0;
      foreach (@{$refcirc->{lisnodoscreados}}) {
          my $obj = $refcirc->{cualobjtextonodo}->{$_}->[0];
          push @cu, "$_: $lugarlista->[$obj]";
          $i ++;
          if ($i eq 4) { 
              push @cuales, "@cu"; @cu = ();$i = 0;
          };   
      };
      push @cuales, "@cu" if @cu; my $cuales = join "\n",@cuales;              
      avnograv("Se crearon los nodos:\n" . $cuales);                
  };
  #impr_debug(__LINE__.' Cont',Dumper $refcirc->{cualobjele});
  my ($cualobjele, $cualobjtextonodo ,$parametros)
        = @{$refcirc}{'cualobjele', 'cualobjtextonodo', 'PARAMETROS'};
  my (%elerepe,%nodorepe,%cuantosnodosrepe);

  foreach my $ele (keys %{$refcirc->{cualobjele}}) {
      if ($ele =~ /^[JECRLT]/ and @{$refcirc->{cualobjele}->{$ele}} >1) {
          $elerepe{$ele} = $refcirc->{cualobjele}->{$ele} 	      
      };
  };
  my @lisnodo0 = (); 
  foreach my $textonodo (keys %{$refcirc->{cualobjtextonodo}}) {
      #no importa el orden
      if ($textonodo eq '0') {
          push @lisnodo0, @{$refcirc->{cualobjtextonodo}->{'0'}};
          next;
      };
      my @lisobjnodos = @{$refcirc->{cualobjtextonodo}->{$textonodo}};
      my $juntos='';
      map($juntos .= $codlista->[$_],@lisobjnodos);
      if ($juntos =~ /N.*N/) {
          $nodorepe{$textonodo} = $refcirc->{cualobjtextonodo}->{$textonodo};
          $cuantosnodosrepe{$textonodo}
               = scalar @{$refcirc->{cualobjtextonodo}->{$textonodo}}  	      
      };  
  }; #for $textonodo
  @lisnodo0 = grep($codlista->[$_] =~ /[Nn]/,@lisnodo0);
  # descartar las tierras
  if (@lisnodo0) {
      porparar1(70,$refcirc
          ,"Nodos sin identificación o con identificación del nodo tierra
	       Corrija la identificación, o use un nodo tierra");
      map(mensaje(descripcion_objeto($_)),@lisnodo0);
      return 70; 
  }; 
  if (scalar keys %elerepe) {
      porparar1(71,$refcirc, "Elementos repetidos:"); 
      foreach my $ele (keys %elerepe) {#no importa el orden
          map(mensaje('    ' . descripcion_objeto($_)),@{$elerepe{$ele}});   
      };
      return 71;  
  };
  if ($codcirc eq 'circuito') {#en controlar_circ 
      if (scalar keys %nodorepe) {
          porparar1(72,$refcirc, "Nodos repetidos no anunciados:
               Corrija identificación del nodo o use nodo con doble trazo"); 
          foreach my $ele (keys %nodorepe) {#no importa el orden
              map(mensaje(descripcion_objeto($_)),@{$nodorepe{$ele}});
          };
          return 72;
      };
  };#if else modelo   
  my (@valorsinelemdef,@elemsinvalor,@valorconraro);
  foreach my $keydato (keys %{$refcirc->{DATOS}}) {
      my $lisobj = $cualobjele->{$keydato};
      if (defined $lisobj) {
          my $obj = $lisobj->[0]; 
	  $refcirc->{ELESPLANT}->{$keydato} = $plantillalista->[$obj];
          next;
      };
      next if $keydato =~ /^D([EJ].*)/ and defined $cualobjele->{$1};
      $keydato =~ /^(.)(.+)$/;
      my ($cod,$texto) = ($1,$2);
      if ($keydato =~ /^D/) {
          porparar1(73,$refcirc,"$keydato no debe figurar en el cuadro DATOS");
          return 73;
      }; 
      if (defined $refcirc->{cualobjnoigno}->{"Z$texto"}  ) {
	  my @cuales = @{$refcirc->{cualobjnoigno}->{"Z$texto"}};
          @cuales = grep ($codlista->[$_] !~ /[RLECJnN]/, @cuales);
          map($_ = $lugarlista->[$_],@cuales);
          push @valorsinelemdef, @cuales;
      } elsif ($keydato =~ /^M/) {#no tienen un objeto grafico asociado 
          push @valorconraro, $keydato;
      };    
  };
  my @nodoseles;
  foreach my $nodo (keys %{$refcirc->{NODOSPLANT}}) {
      if (defined $refcirc->{ELESPLANT}->{$nodo}) {
           porparar1(74,$refcirc,
            "Hay un elemento con igual nombre completo que el nodo $nodo"); 
           return 74;
      }; 
  };
  #salvar elementos nulos creados por simusol REVISAR
  my $codm;
  map(do{ /^(.)/;$codm = $1;
         $refcirc->{'DATOS'}->{$_} = '0'
         if $codm =~ /$codelems/  and not defined $refcirc->{DATOS}->{$_} and
	    $codvalorlista->[$cualobjele->{$_}->[-1]] eq '0'}
     ,keys %$cualobjele);

  map(do{/^(.)/;my $codm = $1;
         push(@elemsinvalor,$_)  
         if (not defined $refcirc->{DATOS}->{$_} and $_!~/^T/i)} 
     ,keys %$cualobjele);
  my $j = 0; 
  foreach my $ele (@elemsinvalor) {
      next if $plantillalista->[$refcirc->{cualobjele}->{$ele}->[0]];
      #la plantilla Auxiliar tiene numero 0
      cargar_datos($refcirc,'DATOS',$ele,0,'n','');
      delete $elemsinvalor[$j]; $j++;
  };
  #impr_debug(__LINE__.' Cont @elemsinvalor', scalar @elemsinvalor);
  #impr_debug(__LINE__.' Cont @valorsinelemdef',\@valorsinelemdef);

  if (@elemsinvalor) {
      porparar1(75,$refcirc,"Malas asignaciones;");
      if (@elemsinvalor) {
          mensaje("Elementos que no recibieron valor:");
          map(mensaje(descripcion_nombre($_,$cualobjele)),@elemsinvalor);
      };
      if (@valorsinelemdef) {
          mensaje(
          "Iconos no definidos para Simusol (@valorsinelemdef), con valor");
      };
      return 75;
  }; 
  if (@valorconraro) {
      avnograv("Objetos no identificados que recibieron valor;"
                . " se ignorarán" );# Que es esto?
      map(do{ /^(.)/;mensaje("$quenombre{$1}  $_: $refcirc->{DATOS}->{$_}");
            delete $refcirc->{DATOS}->{$_};
          } ,@valorconraro); 
  };
  comfin('fin controlar_circ', ['DATOS','PARAMETROS'],$refcirc, '');
  return '';
} #controlar_circ
# --------------------------------------------------------------------------
sub controlar_cadena_param{
  comfin('com controlar_cadena_param', @_);
  #recursividad
  # si detecta cadena recursiva de parametros y/o datos
  # termina luego de llamar a porparar
  my $refc=$_[0];
  #impr_datos(__LINE__.' Cont',['DATOS','PARAMETROS'],$refc);
  my @params = (keys %{$refc->{PARAMETROS}}, keys %{$refc->{DATOS}});
  @params = sort @params; #en controlar_cadena_param
 #impr_debug(__LINE__.' Cont @params',\@params);
  my $hashinme = {}; #contendra los sigientes inmediatos de cada elemento
  foreach my $par (@params) {
      my %hashanterela;
      my $valor = $refc->{PARAMETROS}->{$par} ;
      my $tipvalor = $refc->{TIPPARAMETROS}->{$par};
      defined $valor 
        or do{
            $valor =  $refc->{DATOS}->{$par};
            $tipvalor = $refc->{TIPDATOS}->{$par};
            $valor =~ s/listalis\(\w+\,//;   
      };
      defined $valor or next; 
      next if $tipvalor  eq 'n';
      $valor = '(' . $valor .')';
      #impr_debug(__LINE__.' Cont $par $valor',[$par,$valor]);
      my $npar = $par;
      my $seguir = 1; 

      # @listita contiene parametros o datos que se va sabiendo hay 
      # que revisar
      # @listita pierde al primero luego de encontrados sus inmediatos
      # $hashinme: registra los siguientes inmediatos de cada elemento
      # %hashanterela, los anteriores relativos a la posible recurrencia 
      # desde $par 
      # %hash : los siguientes en general de $par
      my @listita = ();
      my %hash=();
      
      while ($seguir) {
#          if($par eq 'PDM2') {
#              print STDERR "seguimos?"; my $resp = <STDIN>;
#          };
            my @yacalculados = sort keys %$hashinme;
          if (not defined $hashinme->{$npar}) {
              $hashinme->{$npar} = [];
              while ($valor =~ s/\W\s*(([PRLCEJ])\w+)(\W)/$3/) {
                  $3 eq '(' and next;
                  my $pare = $1; my $tipo;
                  my $tippare = $refc->{TIPPARAMETROS}->{$pare};
                  if (not defined $tippare) {
                      $tippare = $refc->{TIPDATOS}->{$pare};
                      defined $tippare or $tippare = '?';
	          };
                  if ($tippare !~ /[n]/i
       # puede ser una variable de la simulacion o un parametro integrado 
                      and not defined $refc->{PARAMETROS}->{"D$pare"}) {
                      push @{$hashinme->{$npar}},$pare; 
	          };              
              }; # while valor        
          };
          my @inmediatosrela = grep(do {not defined $hash{$_}}
                                    , @{$hashinme->{$npar}}); 
          # @inmediatosrela contiene los siguientes inmediatos
          #  que no han sido anteriores
          if (@inmediatosrela == 0) {
              delete $hash{$npar}
          } else {
              foreach my $pare (@inmediatosrela) {
                  not defined $hashanterela{$pare} and
                              $hashanterela{$pare} = $npar; 
                  $pare eq $par and 
		      do {my @listota = ($pare); my $ante = $npar;

                      while ($ante ne $par) {
			  unshift @listota, $ante;
                          $npar = $ante;
                          $ante = $hashanterela{$npar};
                      };
                      parar1(182,$refc,
                      "Se forma cadena recursiva de parámetros y/o datos:
                      desde $par se llega a @listota");
                      return 182; 
		  };
              }; 
              push @listita, @inmediatosrela;
              map(do{$hash{$_} = 1}, @inmediatosrela);
          };  
          if (@listita)  {# hay que sacar de @listita paraseguir
	      $npar = shift(@listita);
              defined  $refc->{PARAMETROS}->{$npar} and
	        $valor = "($refc->{PARAMETROS}->{$npar})"
	      or defined  $refc->{DATOS}->{$npar} and do{
		    $valor = "($refc->{DATOS}->{$npar})";
                    $valor =~ s/listalis\(\w+\,//;   
              }
	      or $seguir ='';	 
          } else {
	      $seguir = '';
	  };   #if else defined $pare
      };#while seguir
  };#foreach $par @params
  comfin('fin  controlar_cadena_parametros');
  return ''; 
}# controlar_cadena_parametros    
# --------------------------------------------------------------------------
sub controlar_iniciales_il_vc{#puede producir avisos
    comfin('com controlar_iniciales_il_vc', @_);
    my $refc = $_[0]; my @sininicial;
    my @listaself = grep (/^L/,keys %{$refc->{cualobjele}});
    my @lista;
    foreach my $ele (@listaself) {
        if (not defined $refc->{INICIALES}->{"I$ele"}) {
            push @sininicial, $ele;
        } else {
            push @lista, "I$ele";        
        }
    };
    if (@sininicial) {
       avgrav("Sin valores iniciales para I's:
           @sininicial")
    };
    @sininicial=();
    my @listacap = grep (/^C/,keys %{$refc->{cualobjele}});
    foreach my $cap (@listacap) {
        if (not defined $refc->{INICIALES}->{"V$cap"}) {
             push @sininicial, $cap;
        } else {
	    push @lista,"V$cap";
        };
    };
    if (@sininicial) {
       avgrav("Sin valores iniciales para V's:
           @sininicial")
    };
    my (@nonum,@tipoQ);
    foreach my $cosa (@lista) {
        my ($valor,$tipo,$tiparg,$refarg) 
              = tomar_datos($refc,'INICIALES',$cosa);
        next if $tipo =~ /[n\,]/;
        push @nonum, $cosa;
    };
    @nonum = grep($refc->{TIPINICIALES}->{$_} =~ /[n\,]/, @nonum); 
    my $coderr = Tablasfuncq::evaluar_q_n($refc,'INICIALES',@nonum) if @nonum;
    $coderr and parar1($coderr, $refc);
    @nonum = grep($refc->{TIPINICIALES}->{$_} =~ /[n\,]/, @nonum); 
    @nonum and avgrav("Hay valores iniciales no numéricos para 
              @nonum");
    $avisosgrav and parar1(66,$refc);
    comfin('fin controlar_iniciales_il_vc',['INICIALES'],$refc,'impr');
}#controlar_iniciales_il
# --------------------------------------------------------------------------
sub controlar_dpar_tiempos{
  my $ref = $_[0];
  my @dpars = grep (/^D/i,keys %{$ref->{PARAMETROS}});
  return unless @dpars;
  #impr_debug(__LINE__.' Cont CONTROLES ', Dumper $ref->{CONTROLES}); 
  my $stop = $ref->{CONTROLES}->{'STOP TIME'};
  return unless $stop =~ /\,/;
  parar1(229,$ref,"Al reiniciar una ejecución con tiempo tartido, 
       los parámetros a integrar vuelven a su valor inicial; 
       sería erróneo continuar el procesamiento");
} #controlar_dpar_tiempos
# --------------------------------------------------------------------------
sub controlar_iniciales_integr{#puede producir avisos graves
   comfin('com controlar_iniciales_integr', @_);
   my ($ref,@lisparD) = @_;
   # en contr. integrables
   #los valores iniciales para parámetros a integrar no deben sustituirse
   # se pasan a INICIALES, si estaban en PARAMETROS
   my (@lisparDsinI);
   #impr_datos(__LINE__.' Cont', ['PARAMETROS','INICIALES'], $ref); 
   #impr_debug(__LINE__.' Cont' ,$ref->{listaPARAMETROS});
   #impr_debug(__LINE__.' Cont'  ,$ref->{listaINICIALES});
   foreach my $pard (@lisparD) {
       my $parverd = substr($pard,1);
       if (defined $ref->{PARAMETROS}->{$parverd}) {
           mover_datos($ref,'PARAMETROS',$parverd,$ref,'INICIALES',$parverd
                       ,__LINE__.' Cont contr.inic.integ');
           push @{$ref->{listaINICIALES}}, $parverd;
           @{$ref->{listaPARAMETROS}} 
	      = grep ($_ ne $parverd, @{$ref->{listaPARAMETROS}});
       };
       #impr_datos(__LINE__.' Cont', ['PARAMETROS','INICIALES'], $ref); 
  #impr_debug(__LINE__.' Cont' ,$ref->{listaPARAMETROS});
  #impr_debug(__LINE__.' Cont'  ,$ref->{listaINICIALES});
       if (not defined $ref->{INICIALES}->{$parverd}) {
	   push @lisparDsinI, $parverd;
       };
   };#foreach $pard   
   @lisparDsinI and do {
        parar1(31,$ref,"Hay que indicar valor inicial para;  @lisparDsinI");
   };     
  # los DP... no deben aparecer en los values;
  # hay que sustituirlos; si aparece recursion avgrav y porparar
  # primer ciclo se sustituye; segundo ciclo si sigue habiendo se corta.
  # busqueda de DP 

  #impr_datos(__LINE__.' Cont contr_DP', ['PARAMETROS'], $ref);
  my %DPusados;
  foreach my $dpar (@lisparD) {
      my $valor = '(' . $ref->{PARAMETROS}->{$dpar} . ')';
      my @listita = ($valor =~ /\W(D\w+)/g);
      map($DPusados{$1} ++,@listita);
  };
  my @DPusados = keys %DPusados;
  @DPusados and do{
      parar1(32,$ref
      ,"No es aceptable utilizar derivadas para asignar valores;
      @DPusados: no deben aparecer a la derecha de signo de igual");
   };
  
  comfin('fin controlar_iniciales_integr', 'integ.:'
                   , 'sin inc:', @lisparDsinI);
   return '';
}#controlar_iniciales_integr
# --------------------------------------------------------------------------
sub controlar_layer{#puede haber avisos y porparar; devuelve codigo
  comfin("com controlar_layer",  @_,descripcion_capa($_[0]));
  my $coderr= 0;
  my $il=$_[0];
  my $avisos=$avisosgrav+$avisosnograv+$avisosnoseent; 
  my $reflay=$reflayer[$il];my $nombrecirc=$nomcirc[$il];
  #imprhash('en controlar_layer',%$reflay);
  my ($cualobjele,  $cualobjtextonodo
      , $lisobjcuadrosdesc, $lisobjcuadrosnoid
      , $listextonodosuna, $listextonodoscero, $elemmenos, $sintexto)
           = @{$reflay}{'cualobjele',  'cualobjtextonodo',
	               'lisobjcuadrosdesc', 'lisobjcuadrosnoid',
	               'listextonodosuna', 'listextonodoscero',
	               'elemmenos','sintexto'};
#  if (defined $cualobjele 
#        and $reflay->{refcirc}->{clasearch} eq 'dibujo' or  
#            $reflay->{refcirc}->{clasearch} eq 'elementos') {   
#  };   
  do{ avgrav("Texto de los nodos no bien conectados:");
      map(mensaje("$_  "),@$listextonodosuna,@$listextonodoscero)
  } if $listextonodosuna or $listextonodoscero;

  do{ avgrav( "Elementos no bien conectados: ");
      map (mensaje(descripcion_objeto($_)),@$elemmenos)
  } if $elemmenos;

  do{ avnograv( "Cuadro(s) sin identificación (Se ignorará(n)): ");
      map (mensaje(" en $lugarlista->[$_]"), @$lisobjcuadrosnoid);
  } if $lisobjcuadrosnoid;
  do{ avnograv
       ("Cuadro(s) con identificación desconocida (Se ignorará(n)): ");
      map (mensaje("      \"$textolista->[$_]\" en $lugarlista->[$_]"), 
           @$lisobjcuadrosdesc);
      mensaje(
          "==== CUIDADO ==== : si cambió algún nombre de cuadro sin querer,  
              puede recibir mensajes de error incomprensibles");     
  } if $lisobjcuadrosdesc;
  if ($avisosgrav) {
      $coderr = 40;
  };
  comfin('fin controlar_layer', " coderr = $coderr"); 
  return $coderr;
}# controlar_layer 
#---------------------------------------------------------------------------
sub controlar_uso_def_parametros{#produce avisos y marca errores
  comfin('com controlar_uso_def_parametros', @_);
  my $ref = $_[0];
  #my @lisvar = keys %{$ref->{USAVAR}};
  my (@parusanodef,@parusasinini);
  #impr_datos(__LINE__.' Cont', ['PARAMETROS'], $ref);
  my (@parnousados,@parusados);
  foreach my $par (keys %{$ref->{PARAMETROS}}) {
      next if $ref->{TIPPARAMETROS}->{$par} eq 'I' or $par =~ /^D/i
	  or $par eq 'coment';
      if (not (defined $ref->{parametroscreados}->{$par} or
               defined $ref->{parametrossustituidos}->{$par} or
               defined $ref->{USAPAR}->{$par} or 
               defined $ref->{USAPARCONTROLES}->{$par}
               )) {
	       #impr_dat_que($par,'PARAMETROS'
               #          ,__LINE__.' Cont parametros no usa',$ref,'pnu');
          push @parnousados, $par; 
      } else {
          push @parusados, $par;
      };
      next if (defined $ref->{USAPAR}->{$par}
               );
      borrar_datos($ref,'PARAMETROS',$par,'',__LINE__.' Cont c_u_d_param.');
      delete $ref->{rerun}->{PARAMETROS}->{$par}
          if defined $ref->{rerun}->{PARAMETROS}->{$par};
      if (defined $ref->{INICIALES}->{$par}) {
	      borrar_datos($ref, 'INICIALES',$par,''
              ,__LINE__.' Cont c_u_d_parametros');
      }; 	  
  };  
  #impr_datos(__LINE__.' Cont', ['PARAMETROS'], $ref);
 
  @parnousados 
        = grep(do{not defined $ref->{dearchivo}->{$_}}, @parnousados); 
  if (@parnousados) {
      my $coderr = Tablasfuncq::resumir_fun_par_tab_var_funx($ref, 'circuito');
      #impr_debug(__LINE__.' Cont', Dumper $ref->{USAPAR});
      map (do {not $ref->{USAPAR}->{$_} and  
       borrar_datos($ref,'PARAMETROS',$_,'',__LINE__.' Cont c_u_d_param.')}
	   , @parusados);
  }
  @parusanodef and do {
      my $cuales = join ' ', @parusanodef;
      avgrav( "Hay parámetros no definidos: $cuales");
      map(cargar_datos($ref, 'PARAMETROS',$_,'no definido','e','',0
            ,__LINE__.' Cont c_u_d_parametros')
          , @parusanodef); 	  
  };#do 

  my @lispar = sort keys %{$ref->{PARAMETROS}};# controlar_uso_def_parametros
  my $lisque = [];
  defined $ref->{listaPARAMETROS} or $ref->{listaPARAMETROS} = [];  
  my $reflispar = $ref->{listaPARAMETROS};
  for (my $ip = 0; $ip < @$reflispar; $ip ++) {
      my $par = $reflispar->[$ip];
      next unless defined $par and defined $ref->{PARAMETROS}->{$par};
      next if $ref->{PARAMETROS}->{$par} eq 'no definido';
      next if length($par)<7; # en controlar_uso_def_parametros
      avgrav("Debe cambiar el nombre a $par;
   no pueden llegar a Sceptre parámetros de nombres de más de 6 símbolos");
  };#for $ip
  # a Sceptre no le gusta que las derivadas se presenten como constantes
  for my $par (keys %{$ref->{PARAMETROS}}) {
      if ($par =~ /^D/ and $ref->{TIPPARAMETROS}->{"$par"} eq 'n') {
          my $valor = $ref->{PARAMETROS}->{$par}; 
	  cargar_datos($ref, 'PARAMETROS', "$par","XXX($valor)", 'x', 'n'
                  ,[$valor]
               ,__LINE__.' Cont c_u_d_parametros');
      };	        
  };#for $par

  comfin('fin controlar_uso_def_parametros');
  return '';
} #controlar_uso_def_parametros
# ---------------------------------------------------------------------------
sub controlar_uso_def_tablas{ 
  comfin('com controlar_uso_def_tablas',@_);
  #aqui llega todo explotado; solo hay que controlar calidad de argumentos
  my $ref = $_[0];
  #impr_debug(__LINE__.' Cont {USATAB}', Dumper $ref->{USATAB});
  #impr_debug(__LINE__.' Cont {USAELE}', Dumper $ref->{USAELE});
  #impr_debug(__LINE__.' %reffi', \%reffi);
  my @eles = keys %{$ref->{USAELE}};
  foreach my $elearch (@eles) {
      my $refele = $reffi{$elearch}; my $coderr = '';
      $coderr = depurar_tablas_archivos($refele) 
          if $refele->{refvalores}->{TABLAS_ARCHIVOS};
      $coderr and parar1(66,$ref,"Errores en tabla definida junto con elementos
          TABLAS_ARCHIVOS de $elearch");   
  };
  my @tablasnodefinidas;
  foreach my $id (keys %{$ref->{USATAB}}) {#no importa el orden
      $id =~ s/^.//; 
      if (not defined $hash_tablas_definidas{$id}) {  
          push @tablasnodefinidas, "Tabla $id (T$id)  ";
          avnograv(
            "Tabla(s) no definidas o las expresiones no se refieren a tablas:
        @tablasnodefinidas");
      };
  }; 
  #impr_debug(__LINE__.' Cont %hash_tablas_definidas'
  #          , "$ref->{ABSOLUTO} ".Dumper \%hash_tablas_definidas);
  my @tablasnousadas;
  foreach my $idtabla (keys %hash_tablas_definidas) {
      if (not defined $ref->{USATAB}->{"T$idtabla"} 
	  and $hash_tablas_definidas{$idtabla} ->{$ref->{ABSOLUTO}}) {
          push @tablasnousadas, "   Tabla $idtabla"; 
          delete $hash_tablas_definidas{$idtabla}; 
      }
  };
  avnograv("Tabla(s) no usada(s):\n @tablasnousadas") if @tablasnousadas;
  comfin('fin controlar_uso_def_tablas');
  return '';
}#controlar_uso_def_tablas
# ---------------------------------------------------------------------------
sub controlar_def_funciones_propias{
  #solo guarda en el propio $ref 
  comfin('com controlar_def_funciones_propias', @_);
  my ($ref)=@_;
  my $op = '[\+\-\*\/\(\)]';
  #impr_datos(__LINE__.' Cont', ['FUNCIONES'], $ref);
  foreach my $nombre (keys %{$ref->{FUNCIONES}}) {
     next if $ref->{TIPFUNCIONES}->{$nombre} eq ';'; 
     my ($nombrefun,$stringarg) = ($nombre =~ /^(Q\w+)\((.+)\)$/);
      my @listaarg =  split '\s*,\s*', $stringarg;
      scalar @listaarg == scalar union_conjunto(@listaarg) or
      do{ porparar1(75,$ref
         ,"Argumentos repetidos en la definición de $nombre");
	  return 75;
      };
      my @malos = grep (do{/\W/ or /^\d/} ,@listaarg);
      if (@malos) {
          porparar1(76,$ref,"En $nombre hay argumentos no válidos: @malos");
          return 76;
      }; 
      @{$ref->{listaargFUNCIONES}->{$nombrefun}} = @listaarg;
      #para evitar cocientes de enteros
      my $valor = $ref->{FUNCIONES}->{$nombre};
      while ($valor=~ s/(\/\d+)($op)/$1\.$2/) {}; 
       my $tipo = $ref->{TIPFUNCIONES}->{$nombre};
      $tipo eq 'x' and $valor =~ s/^X\w+//
          or $valor ="($valor)"; 
      #para evitar argumentos num. pasados a SIGN que no sean de doble precision
       while ($valor =~  s/(\W)(TIEMPO)(\W)/$1TIME$3/i) {};
      $ref->{FUNCIONES}->{$nombre} = $valor;
      $ref->{definicionFUNCIONES}->{$nombrefun} = "$nombre = $valor";
  };
  comfin('fin controlar_def_funciones_propias');
  return '';
}
# ---------------------------------------------------------------------------
sub controlar_def_funciones_todas{
  comfin('com controlar_def_funciones_todas', @_);
  my ($refc)=@_;
  my $coderr= '';
  my %funcusafunq;
  impr_datos(__LINE__.' Cont', ['FUNCIONES'], $refc);
  $refc->{no_formales} = {};
  #aceptamos que en las funciones_Q aparezcan argumentos no_formales: 
  # variables de la simulacion (además del posible TIME)
  impr_debug(__LINE__.' Cont %hash_funciones_definidas'
       , Dumper \%hash_funciones_definidas);
  impr_debug(__LINE__.' Cont definicionFUNCIONES'
       , Dumper $refc->{definicionFUNCIONES});
  foreach my $qfunori (sort keys %{$refc->{definicionFUNCIONES}}) {
      my %funcusavar;
      my $defi = $refc->{definicionFUNCIONES}->{$qfunori};
      my ($izquierda,$derecha) = $defi =~ /^(\S+)\s*=\s*(\S+)$/;
      my $dere = $derecha;
      my @listarg = @{$refc->{listaargFUNCIONES}->{$qfunori}};
      print STDERR __LINE__.' Cont listaargFUNCIONES ', Dumper $refc->{listaargFUNCIONES};
      print STDERR __LINE__.' Cont TIPARGFUNCIONES ', Dumper $refc->{TIPARGFUNCIONES};
      print STDERR __LINE__.' Cont REFARGFUNCIONES ',Dumper $refc->{REFARGFUNCIONES};
      my %argesta;
      map($argesta{$_}= 1, @listarg);
      # para detectar uso de tablas:
      # if ($texto =~ /\WT[\s\w]+\(/ ) {}; 
      # para 'eliminar' nombres de funciones:
#      while ($dere =~ s/(\W)(\w+)\(/$1\&\(/) {
#          my $func = $2;
#          $funcusafunq{$qfunori}->{$func} = 1 if $func =~ /^Q/i;
#      };
      #@{$funcusafunq{$qfunori}} funciones que inciden en definición
 #     impr_debug(__LINE__.' Cont $refc',Dumper $refc->{REFARGFUNCIONES});
 #     (my $vari = $defi) =~ s/^(.*) =.*$/$1/;
      #     impr_debug(__LINE__.' Cont $vari',Dumper $vari);
       my $vari
        = $qfunori."(".join(',',@{$refc->{listaargFUNCIONES}->{$qfunori}}) .")";
       my @cosas = split /[\+\-\*\/\(\)]/, $refc->{FUNCIONES}->{$vari};
       @cosas = grep ($_,@cosas);
       impr_debug(__LINE__.' Cont @cosas',\@cosas);
       my @tipos = split '',$refc->{TIPARGFUNCIONES}->{$vari};
       my %tipouso; 
       for(my $i = 0; $i < @cosas; $i++) {
#	   print STDERR __LINE__.' Cont ',"$cosas[$i] $tipos[$i]\n";
	   $tipouso{$cosas[$i]} = $tipos[$i];#no se esperan conflictos
           $funcusavar{$cosas[$i]} = 1 if $tipos[$i] !~ /[na]/;
   # arg.form  TIEMPO  o TIME y funciones conocidas del FORTRAN tienen tipo 'a' 
      };	  
      #@cosas variables que inciden en definición
      #a veces, Sceptre, trabajando con circuitos grandes, 
      # no acepta argumentos con un solo caracter : a, x, w
      # por las dudas aviso para todos
      #en {$refc->{no_formales} apunta a un hash: 
         #key: nombre de parametro o variable no argmento formal 
               #de una funcion y distinto de TIME;
         #value:  lista de funciones que lo usan.
      # si la key es un parametro que varia durante la simulacion, 
      # pero no esta entre los outputs, Sceptre no lo tiene en cuenta  
      foreach (keys %funcusavar) {
	  if (not defined $argesta{$_} and $_ ne 'TIEMPO' and $_ ne 'TIME') {
	      push @{$refc->{no_formales}->{$_}},$qfunori;
          };    
      };# marca variables que inciden sin ser argumentos formales 
      my (%argusde1,@argnous);
      foreach (@listarg) {
	  not defined $tipouso{$_} and  push @argnous, $_;
          length($_) == 1 and $argusde1{$_} = 1; 
          #para no modificar si no influye
      };#foreach @listarg 
      #impr_debug(__LINE__.' Cont %argusde1 ' , Dumper \%argusde1);
      if (keys %argusde1) {
         avnograv("$izquierda tiene argumentos de una sola letra:
                  en $izquierda = $derecha
             pueden traer problemas; las cambiaremos");
          my $defi = $refc->{definicionFUNCIONES}->{$qfunori};
          foreach my $uno (@listarg) {
              next unless $argusde1{$uno};
              my $sust = $uno.'1';
              while ($funcusavar{$sust}) {$sust++};
              delete $funcusavar{$uno}; $funcusavar{$sust} = 1;
              while ($defi =~ s/(\W)$uno(\W)/$1$sust$2/) {};
              $uno = $sust;          
          };
         $refc->{definicionFUNCIONES}->{$qfunori} = $defi;
	 $refc->{listaargFUNCIONES}->{$qfunori} = \@listarg;
#impr_debug(__LINE__.' Cont listaarg ', Dumper $refc->{listaargFUNCIONES});
#impr_debug(__LINE__.' Cont definicion ',Dumper $refc->{definicionFUNCIONES});
      };
      @argnous and avnograv("Hay agumentos no usados
              @argnous
           en la definición $izquierda = $derecha");  
      #impr_debug(__LINE__.' Cont  valor que define funcion', $valor); 
  };#foreach qfunori
  #imprhash(__LINE__. ' Cont ',%$refc);
  #impr_debug(__LINE__. ' Cont FUNCIONES',Dumper $refc->{FUNCIONES});
  #impr_debug(__LINE__. ' Cont REFARGFUNCIONES'
  #    , Dumper $refc->{REFARGFUNCIONES});
  comfin('fin controlar_def_funciones_todas');
  return '';
}#controlar_def_funciones_todas
# ---------------------------------------------------------------------------
sub controlar_def_funciones_final{
  comfin('com controlar_def_funciones_final',@_);
  my ($refc)=@_;
  my @cosas = keys %{$refc->{no_formales}};
  #aceptamos que en las funciones_Q aparezcan argumentos no_formales: 
  # variables de la simulacion (además del posible TIME)
  impr_debug(__LINE__.' Cont no_formales ',\@cosas);
  foreach my $cosa (@cosas) {
      my $que = '';
      #no sirve nombre de nodo
      if ($cosa =~ /^P/ and defined $refc->{PARAMETROS}->{$cosa}
            or defined $refc->{PARAMETROS}->{"D$cosa"}) {
          $que = 'PARAMETROS';
      } elsif ($cosa =~ /^[RCLEJ]/ and defined $refc->{DATOS}->{$cosa}) {
          $que = 'DATOS';
      } elsif ($cosa =~ /^V([RCLJ].+)$/ and defined $refc->{DATOS}->{$1}) {
      } elsif ($cosa =~ /^I([RCLE].+)$/ and defined $refc->{DATOS}->{$1}) {
      } else {
          avgrav("No se reconoce variable que interviene en funcion(es):
           $cosa en @{$refc->{no_formales}->{$cosa}};
         Puede ser que Sceptre tome un valor 0 para $cosa");
      };
      next unless defined $que;
      if (defined $refc->{"TIP$que"}->{$cosa} 
          and $refc->{"TIP$que"}->{$cosa} eq 'n') {
          my $sust = $refc->{$que}->{$cosa};
          my @funcs = @{$refc->{no_formales}->{$cosa}};
          foreach my $func (@funcs) {
              my $defi = $refc->{definicionFUNCIONES}->{$func};
              while ($defi =~ s/(\W)$cosa(\W)/$1$sust$2/) {};
          };
      } else {
          if ($que eq 'PARAMETROS') {
	      my $texto = Dumper($refc->{lisoutputssceptre})
                          . Dumper($refc->{DATOS});
              #my $stringsceptre = join ';',@{$refc->{lisoutptssceptre}}; 
	      #impr_debug(__LINE__.' Cont $texto ', $texto);
              $texto =~ /\W$cosa\W/ or do{
               # ";$stringsceptre;" =~ /\;$cosa\;/  or do{
                    push @{$refc->{lisoutputssceptre}},$cosa; 
                    push @{$refc->{lispropiasvars}},$cosa; 
                    push @{$refc->{lisunidades}},'??'; 
                    push @{$refc->{lismagnitudes}},'??'; 
                    push @{$refc->{listacomeRESU}}
		    , "; $cosa agregado por Simusol porque afecta funciones";
		    push @{$refc->{indicebueno}}
		    ,scalar (@{$refc->{lisoutputssceptre}});
              }; 
          };
      };    
      #impr_resultados(__LINE__.' Cont contr_def_fun', $refc);
  }
  comfin('fin controlar_def_funciones_final');
}#controlar_def_funciones_final
# ---------------------------------------------------------------------------
sub controlar_uso_funciones{#puede producir mensajes de error
  #como las funciones_Q no pueden ser invocadas ni en expresiones,(falso)
  #ni en tablas ni en otras funciones, y al sceptre llegan con 
  #argumentos simples es mas facil controlar luego de explotar
  #se controla que las funciones usadas hayan sido definidas
  #y se esten usando con los argumentos necesarios
  # y avisa si hay funciones definidas en el principal que no se esten usando
  comfin('com controlar_uso_funciones', @_);
  my ($refc)=@_; my $coderr = '';
  my @lisque = ('DATOS','PARAMETROS');
  my %funcnodef; 
  foreach my $que (@lisque) {
      foreach my $key (keys %{$refc->{$que}}) {
          my $valueori = $refc->{$que}->{$key};
          next unless ";$valueori" =~ /\WQ\w+\s*\(/i;
	  my $value = $valueori;
          $value =~ s/(\WQ\w+)\s*\(/$1&\(/ig;
          while ($value =~ s/(.*\W)(Q\w+)&\s*(\(.+$)/$1$2$3/) {
	      my ($pre,$func,$resto) = ($1,$2,$3);
              next if $func eq 'QPRODUCTO' or $func eq 'QSUMA';
              next if $func =~ /^Q\d+P$/ or $func =~ /^Q\d+S$/;
	      my ($parte1,$parte2) = cerrar_paren($resto);
              impr_debug(__LINE__.' Cont DOLO $parte1,||,$parte2'
			 ,[$parte1,'||',$parte2]);
              (my $stringarg = $parte1) =~ s/^\((.*)\)$/$1/;
	      impr_debug(__LINE__.' Cont DOLO $stringarg',$stringarg);
              my @listarg = split ',', $stringarg;    
              impr_debug(__LINE__.' ContDOLO @listarg',Dumper \@listarg);
              defined $refc->{definicionFUNCIONES}->{$func}
                or do {
                  $funcnodef{$func} = 1;next
                };
	      ($coderr,@listarg) = juntar_por_paren(',',@listarg);
              impr_debug(__LINE__.' ContDOLO @listarg',Dumper \@listarg);
	      if ($coderr) {
	          impr_debug(__LINE__
                    .' Cont $key $func $pre $func $resto $stringarg @listarg '
                    ."$key $func $1 $2 $3 $stringarg $valueori $value"
			     ,Dumper \@listarg);
              }; 		 
              @listarg == @{$refc->{listaargFUNCIONES}->{$func}}
	            or avgrav(
              "Se está usando una función con cantidad de argumentos 
              distinta de la cantida necesaria. $func requiere  " 
              .scalar @{$refc->{listaargFUNCIONES}->{$func}} ." argumentos
        pero se esta usando con " . scalar @listarg . " en
        $func(" .  join(',',@listarg). ')');last;
	      $value = "$pre$func$resto";     
          };#while
      };#foreach key
  };#foreach que
  scalar keys %funcnodef and explic(
     "Hay funciones con nombre que empieza con \"Q\" no definidas aquí;
                  salvo que haya un programa en FORTRAN ...
                   Sceptre no funcionará: 
         " . join (' ', keys %funcnodef) );
  #impr_debug(__LINE__.' Cont USAFUN', Dumper $refc->{USAFUN});
  #impr_debug(__LINE__.' Cont FUNCIONES', Dumper $refc->{FUNCIONES}); 
  my @funcionesnousadas;
  foreach my $key (keys %{$refc->{FUNCIONES}}) {
      (my $fu = $key) =~ s/^(\w+).*/$1/;
      defined $refc->{USAFUN}->{$fu} or push @funcionesnousadas, $fu;  
  };
  avnograv("Hay funciones que no se están usando:\n  @funcionesnousadas")
      if @funcionesnousadas;
  comfin('fin controlar_uso_funciones', ['DATOS','PARAMETROS'], 'impr');
  return '';
}#controlar_uso_funciones
 # --------------------------------------------------------------------------
sub controlar_var{ #puede producir mensajes de error
  comfin('com controlar_var', @_);
  my ($ref, $aignorar) = @_;
  defined $aignorar or $aignorar = {};
  #impr_datos(__LINE__.' Cont', ['CONTROLES'], $ref);
  #impr_debug(__LINE__.' Cont $ref->{USAVAR}',Dumper $ref->{USAVAR});
  my @noesperadas;
  foreach my $var (keys %{$ref->{USAVAR}}){#
      #fue calculadp en base a DATOS,PARAMETROS,RESULTADOS,CONTROLES 
      # pero las que provienen de CONTROLES no influyen
      #contiene las variables no clasificadas como parametros o  nodos
      my ($cod,$resto) = ($var =~ /^(.)(.*)$/);
      defined $ref->{DATOS}->{$var}
        or (defined $ref->{DATOS}->{$resto} and $cod =~ /[VI]/)
	or (defined $ref->{cualobjtextonodo}->{$resto} and $cod eq 'V')
        or $var eq 'TIEMPO'
        or $var eq 'TIME'
        or defined $aignorar->{$var} 
        or $var =~ /\_nodomod/i
        or push @noesperadas, $var;
  };
  if (@noesperadas) {
      #impr_debug(__LINE__.' Cont @noesperadas ',\@noesperadas);
      my %defini = (%{$ref->{DATOS}},%{$ref->{PARAMETROS}});
      my @usan;
      foreach my $noesp (@noesperadas) {
          push (@usan, grep(";$defini{$_};" =~ /\W$noesp\W/
			    , keys %defini));
          my ($clase,$idenpro) = ($noesp =~ /^(.)(.+)$/);
          if (defined $clase) {
              explic("No hay un elemento apropiado con esa identificaión:
                variable $noesp;  clase $clase;  identificación $idenpro");
          } else {
              explic("Variable no esperada $noesp");
          }; 
     };
      @usan = union_conorden(@usan);
      avgrav("No se reconoce: la(s) variable(s) 
      @noesperadas  usada(s) por   @usan")  if @usan;     
  };
  comfin('fin controlar_var');
}#controlar_var
# ---------------------------------------------------------------------------
sub controlar_tiempos{
  comfin('con controlar_tiempos');
  # controla que las listas de tiempo para STOP TIME sean crecientes
  # y si hay tablas dependientes del tiempo que cubran todo el rango
  my $ref= $_[0];
    #valores por defecto
  if (not $ref->{'STOP TIME'}->{lista}) {
      $ref->{'STOP TIME'}->{lista} = [$fintiempo];
      mensaje( "No se ha indicado cuánto tiempo debe durar la simulación.
         Pensaremos que, en un cuadro con nombre TIEMPO,  se ha escrito
         180 min");
  };    
  if (not $ref->{'START TIME'}->{lista}) {
      $ref->{'START TIME'}->{lista} = [$comitiempo ];
  };    
  if (not defined  $ref->{'STOP TIME'}->{tiempoorig}) {
      $ref->{'STOP TIME'}->{tiempoorig} = $origfintiempo;
  };    
  if (not defined  $ref->{'START TIME'}->{tiempoorig}) {
      $ref->{'START TIME'}->{tiempoorig} = 
       '0 '. $ref->{'STOP TIME'}->{unidad}; 
  };
  my ($tipostart,$tipostop) = ('n','n');
  if (@{$ref->{'START TIME'}->{lista}}>1) {$tipostart =','};
  if (@{$ref->{'STOP TIME'}->{lista}}>1) {$tipostop =','};
  cargar_datos($ref,'CONTROLES','START TIME'
      , join (',', @{$ref->{'START TIME'}->{lista}}),$tipostart,'',0);
  cargar_datos($ref,'CONTROLES','STOP TIME'
      , join (',', @{$ref->{'STOP TIME'}->{lista}}),$tipostop,'',0);
  $ref->{unitiempo} = $ref->{'STOP TIME'}->{unidad};
  $ref->{nomtiempo} = 'tiempo';
  my @lista = @{$ref->{'STOP TIME'}->{lista}};
  my $start = $ref->{'START TIME'}->{lista}->[0];
  my $bien;
  $bien = $start < $lista[0] and do{
      for(my $i = 0; $i < @lista -1; $i++) {
	  $bien = $lista[$i] < $lista[$i+1] or last
      };
  };
  $bien or do{
      unshift @lista, $start;
      my $lista =  join ' < ',@lista ;
      avgrav("Los tiempos no cumplen:
                 $lista");
      parar1(221,$ref,'');       
  };
  my $cual = 'TIEMPO';
  my $stop = $lista[-1];
  my @amirar = (values %{$ref->{DATOS}},values %{$ref->{PARAMETROS}});
  my $amirar = join ';', @amirar;
  my @listatablas = ($amirar =~ /\WT(\w+)\($cual\)/g);
  #push @listatablas,  ($amirar =~ /\WXTABLE\(T(\w+)\,$cual\)/g);
  @listatablas = union_conjunto @listatablas;
  #impr_debug(__LINE__.' Cont @listatablas ', \@listatablas);
  #impr_tablas(__LINE__.' Cont', $ref);
  foreach my $idtabla (@listatablas) {
      my $reftabla = $ref->{defiTABLAS}->{$idtabla};
      next unless $reftabla;
       #el que no esté definida  (.. u otra cosa) se deja para el final
      my $startt = $reftabla->{absTABLAS}->{$idtabla}->[0]; 
      my $stopt = $reftabla->{absTABLAS}->{$idtabla}->[-1];
      $startt <= $start and $stopt >= $stop or do{
          parar1(142,$ref, "Tabla con rango de tiempo deseado no cubierto:
       TABLA$ idtabla  deseado: ($start, $stop); cubierto: ($startt, $stopt)")
      };       
  }
}#controlar_tiempo
# ---------------------------------------------------------------------------
sub controlar_largos{#de nombres de: 
       #nodos, elementos, parametros, funciones, tablas
    my $refc = $_[0];
    foreach my $il (@{$refc->{capas}}) {
        my $reflay = $reflayer[$il];
        my @nombresl 
             = grep(length($_) > 6, keys %{$reflay->{cualobjtextonodo}});
        if (@nombresl) {
            avgrav("Identificadores demasiado largos para nodos:
            @nombresl");
	    my @valores= keys %{$refc->{uni}};my @valoresl;
            foreach my $nodo (@nombresl) {
                push @valoresl, grep(do{";$refc->{uni}->{$_};" =~ /\W$nodo\W/}
				     , @valores);
            };
            foreach (@valoresl) {
                $refc->{uni}->{$_} .= "; nodo demasiado largo";
            };
        }; 
        @nombresl = grep(do{/[^T]/ and length($_) > 5}
             , keys %{$reflay->{cualobjele}});
        if (@nombresl) {
            avgrav("Identificadores demasiado largos para  elementos:
            @nombresl");
            foreach (@nombresl) {
                $refc->{DATOS}->{$_} .= "; $_ es demasiado largo";
            };
        }; 
    };
  comfin('fin controlar_tiempos');

};

1;
